expectvalue /String
run
(Object subclass: 'GciTsLibrary' 
  instVarNames:#( version callouts calloutSigs cLibrary )
  classVars: #()
  classInstVars: #()
  poolDictionaries: #()
  inDictionary: Globals
  options:#() ) definition
%
set class GciTsLibrary
removeallmethods
removeallclassmethods

classmethod
comment
^ 'A GciTsLibrary represents a loaded CLibrary for ffi access to the
   thread safe GCI functions in $GEMSTONE/include/gcits.hf. '
%

classmethod: 
newForVersion: verString product: pathArg
  | res hdr path hdrPath libPath suffix |
  (res := self new )
    version: verString . "checks verString"
  path := pathArg.
  path last == $/ ifFalse:[ (path := path copy) add: $/ ].
  hdrPath := path, 'include/gcits.hf'  .
  suffix := ((System gemVersionReport at: 'gsBuildArchitecture') at:1 equals:'Darwin')
             ifTrue:[ '-64.dylib' ] ifFalse:[ '-64.so' ].
  libPath := path, 'lib/libgcits-', verString, suffix .
  hdr := CHeader path: hdrPath .
  res 
    libPath: libPath ;
    _initCallouts: hdr .
  ^ res 
%
classmethod:
newDefault
  | ver |
  ver := System _gemVersion copyFrom: 1 to: 5 . "example result 3.5.3"
  ^ self newForVersion: ver product: '$GEMSTONE'
%
method:
callouts
  ^ callouts
%
method:
version: verString
  "can't yet load v3.4.x libs into a 3.5 VM , see bug 48749" 
  #( '3.5.3' '3.6.0' ) detect:[:str| (verString at: 1 equals: str) ].
  version := verString
%
method:
libPath: aPath
  cLibrary := CLibrary named: aPath .
%
method:
_initCallouts: aCHeader
 | fcts list |
 callouts := { } .
 calloutSigs := { } .
 fcts := aCHeader functions .
 list := #( 
    'GciTsLogin'  "order of list must match offsets used in GsTsExternalSession"
    'GciTsLogout'
    'GciTsAbort'
    'GciTsCommit'
    'GciTsExecute'
    'GciTsPerform'
    'GciTsContinueWith' "7"
    'GciTsClearStack' 
    'GciTsFetchObjInfo'
    'GciTsNbLogout'  "10"
  ) copy .
  version >= '3.5.3' ifTrue:[ 
   list addAll: #( 
    'GciTsNbPerform' "11"
    'GciTsNbResult'
    'GciTsSocket' 
    'GciTsNbExecute' )
  ].
  "todo, add more functions"
  list  do:[ :fn | | f c |
   f := fcts at: fn .
   c := (f cCalloutForLibrary: cLibrary) copy .
   c coerceNameToSymbol . "for efficient consistency checks in GsTsExternalSession"
   callouts add: c .
   calloutSigs add: c signatureString .
 ].
% 
